# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section		free

Name:		cargo
Version:	0.8
Release:	2jpp_1rh
Epoch:		0
Summary:	Cargo container wrapper
License:	Apache Software License 2.0
Url:		http://cargo.codehaus.org/
Group:		Development/Libraries
#Vendor:		JPackage Project
#Distribution:	JPackage
Source0:	cargo-0.8-src.tar.gz
# svn export https://svn.cargo.codehaus.org/cargo/cargo/tags/0.8

#Source1:        pom-maven2jpp-depcat.xsl
#Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        cargo-pom-maven2jpp-mapdeps.xsl
Source4:        cargo-0.8-jpp-depmap.xml

Requires:	javamail
Requires:	log4j
Requires:	servletapi4
BuildRequires:	maven >= 0:1.1
#BuildRequires:  jetty4
BuildRequires:	junit
BuildRequires:	jmock
BuildRequires:  xmlunit
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  jakarta-commons-codec
BuildRequires:  jaxp = 1.3
BuildRequires:  jdom
BuildRequires:  jline
BuildRequires:  geronimo-j2ee-deployment-1.1-api
BuildRequires:  geronimo-j2ee-1.4-apis
BuildRequires:  gnu.trove
BuildRequires:  servletapi4
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  ant >= 0:1.6
Requires:  jakarta-commons-codec
Requires:  jaxp = 1.3
Requires:  jdom
Requires:  jline
Requires:  geronimo-j2ee-deployment-1.1-api
Requires:  geronimo-j2ee-1.4-apis
Requires:  gnu.trove
Requires:  servletapi4
Requires:  xalan-j2
Requires:  xerces-j2
Requires:  xml-commons-apis

BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Cargo is a thin wrapper around existing containers (e.g. J2EE 
containers). It provides different APIs to easily manipulate 
containers.
Cargo provides the following APIs:
* A Java API to start/stop/configure Java Containers and deploy 
  modules into them. We also offer Ant tasks, Maven 1, Maven 2, 
  Intellij IDEA and Netbeans plugins.
* A Java API to parse/create/merge J2EE Modules


%package maven-plugin
Summary:        Cargo Maven Plugin
Group:          Development/Libraries/Java
Requires:       maven >= 0:1.1
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description maven-plugin
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{name}-%{version}-src
# remove all binary libs
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar" | grep -v test/resources); do
	mv $j $j.no
done
# FIXME
rm core/containers/tomcat/src/test/java/org/codehaus/cargo/container/tomcat/TomcatWARTest.java
rm -rf extensions/intellijidea
rm -rf extensions/maven2
rm -rf extensions/netbeans

for m in $(find . -name maven.xml); do
    sed -e 's|checkstyle,jar:install|checkstyle,jar:install,javadoc:generate|' \
	$m > tempf
    cp tempf $m
done
rm tempf

%build
#export DEPCAT=$(pwd)/cargo-0.8-depcat.new.xml
#echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
#echo '<depset>' >> $DEPCAT
#for p in $(find . -name project.xml); do
#    pushd $(dirname $p)
#    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
#    popd
#done
#echo >> $DEPCAT
#echo '</depset>' >> $DEPCAT
#/usr/bin/saxon $DEPCAT %{SOURCE2} > cargo-0.8-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven

pushd core
maven \
	-Dmaven.checkstyle.fail.on.violation=false \
	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL
pushd uberjar
maven \
	-Dmaven.checkstyle.fail.on.violation=false \
	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL
popd
popd
pushd extensions
maven \
	-Dmaven.checkstyle.fail.on.violation=false \
	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL
popd

# All done. Cleanup the temporary test directory (cargo does not clean up 
# /tmp/cargo that is created during tests)
rm -rf /tmp/cargo

%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 core/api/container/target/%{name}-core-api-container-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-api-container-%{version}.jar
install -m 644 core/api/generic/target/%{name}-core-api-generic-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-api-generic-%{version}.jar
install -m 644 core/api/module/target/%{name}-core-api-module-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-api-module-%{version}.jar
install -m 644 core/api/util/target/%{name}-core-api-util-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-api-util-%{version}.jar
install -m 644 core/containers/geronimo/target/%{name}-core-container-geronimo-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-geronimo-%{version}.jar
install -m 644 core/containers/jboss/target/%{name}-core-container-jboss-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-jboss-%{version}.jar
install -m 644 core/containers/jetty/target/%{name}-core-container-jetty-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-jetty-%{version}.jar
install -m 644 core/containers/jo/target/%{name}-core-container-jo-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-jo-%{version}.jar
install -m 644 core/containers/orion/target/%{name}-core-container-orion-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-orion-%{version}.jar
install -m 644 core/containers/resin/target/%{name}-core-container-resin-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-resin-%{version}.jar
install -m 644 core/containers/tomcat/target/%{name}-core-container-tomcat-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-tomcat-%{version}.jar
install -m 644 core/containers/weblogic/target/%{name}-core-container-weblogic-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-container-weblogic-%{version}.jar
install -m 644 core/uberjar/target/%{name}-core-uberjar-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-core-uberjar-%{version}.jar
install -m 644 extensions/ant/target/%{name}-ant-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-ant-%{version}.jar

# create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
install -m 644 extensions/maven/target/%{name}-maven-plugin-%{version}.jar \
 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins/maven-%{name}-plugin-%{version}.jar
pushd $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
ln -sf maven-%{name}-plugin-%{version}.jar maven-%{name}-plugin.jar
popd


install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/container
cp -pr core/api/container/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/container
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/generic
cp -pr core/api/generic/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/generic
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/module
cp -pr core/api/module/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/module
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/util
cp -pr core/api/util/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/api/util
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/jboss
cp -pr core/containers/jboss/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/jboss
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/jetty
cp -pr core/containers/jetty/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/jetty
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/jo
cp -pr core/containers/jo/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/jo
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/orion
cp -pr core/containers/orion/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/orion
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/resin
cp -pr core/containers/resin/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/resin
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/tomcat
cp -pr core/containers/tomcat/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/tomcat
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/weblogic
cp -pr core/containers/weblogic/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core/containers/weblogic
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/extensions/ant
cp -pr extensions/ant/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/extensions/ant

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp distribution/LICENSE $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE
%{_javadir}/%{name}/*.jar

%files maven-plugin
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}/LICENSE
%{_datadir}/maven/repository/JPP/plugins/maven-%{name}-plugin*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Tue Apr 25 2006 Fernando Nasser <fnasser@redhat.com> 0:0.8-2jpp_1rh
- First Red Hat build

* Thu Apr 06 2006 Fernando Nasser <fnasser@redhat.com> 0:0.8-2jpp
- Require jaxp = 1.3
- Disable use of maven-findbugs-plugin as findbugs must be built with Java 1.5

* Thu Apr 06 2006 Ralph Apel <r.apel at r-apel.de> 0:0.8-1jpp
- First (JPP-1.7) release

